// IR Speed Measurement using OTronic IR Obstacle Avoidance Sensor
#include <Wire.h>
#include <LiquidCrystal_I2C.h>

LiquidCrystal_I2C lcd(0x27, 16, 2); // set the LCD address to 0x27 for a 16 chars and 2 line display

int IRPin1 = 2;
int IRPin2 = 8;
float Distance = 0.06;
bool ObjectDetected1 = false;
bool ObjectDetected2 = false;
unsigned long StartTime1 = 0;
unsigned long StartTime2 = 0;
unsigned long EndTime1 = 0;
unsigned long EndTime2 = 0;
unsigned long TimeTaken1 = 0;
unsigned long TimeTaken2 = 0;
float TimeSeconds1 = 0;
float TimeSeconds2 = 0;
float Speed1 = 0;
float Speed2 = 0;


void setup() {
  Serial.begin(9600);
  pinMode(IRPin1, INPUT_PULLUP);
  pinMode(IRPin2, INPUT_PULLUP);

}

void loop() {
  int IRState1 = digitalRead(IRPin1);
  int IRState2 = digitalRead(IRPin2);

  if (!ObjectDetected1 && IRState1 == 0){
    ObjectDetected1 = true;
    StartTime1 = micros();
  }
  if (ObjectDetected1 && IRState1 == 1){
    EndTime1 = micros();
    TimeTaken1 = EndTime1 - StartTime1;

    TimeSeconds1 = TimeTaken1 / 1000000.0;
    Speed1 = Distance / TimeSeconds1;

  if (TimeSeconds1 >= 0.001){
    Serial.print("Time taken from first: ");
    Serial.print(TimeSeconds1, 6);
    Serial.print(" s, Speed: ");
    Serial.print(Speed1, 2);
    Serial.println(" m/s");
  }
  ObjectDetected1 = false;
  }

  if (!ObjectDetected2 && IRState2 == 0){
    ObjectDetected2 = true;
    StartTime2 = micros();
  }
  if (ObjectDetected2 && IRState2 == 1){
    EndTime2 = micros();
    TimeTaken2 = EndTime2 - StartTime2;

    TimeSeconds2 = TimeTaken2 / 1000000.0;
    Speed2 = Distance / TimeSeconds2;

  if (TimeSeconds2 >= 0.001){
    Serial.print("Time taken from second:");
    Serial.print(TimeSeconds2, 6);
    Serial.print(" s, Speed: ");
    Serial.print(Speed2, 2);
    Serial.println(" m/s");
  }
  ObjectDetected2 = false;
  }
  if (TimeSeconds1 >= 0.001 && TimeSeconds2 >= 0.001){
    lcd.setCursor(1, 0);
    lcd.print("Begin:");
    lcd.print(Speed1);
    lcd.print("m/s");
    lcd.setCursor(1, 1);
    lcd.print("Eind:");
    lcd.print(Speed2);
    lcd.print("m/s");
    delay(5000);
    lcd.clear();
    TimeSeconds1 = 0;
    TimeSeconds2 = 0;
  }
}

